package node.exprNode.prefixNode;

import env.*;
import code.*;
import node.exprNode.*;

public abstract class PrefixNode extends ExprNode {

	protected String operator;
	protected String opCode;
	protected ExprNode right;

	public PrefixNode( ExprNode right ) {
		this.right = right;
		}
		
	public String toString() {
		return operator + " " + right.toString( precedence );
		}

	public void evalCode( int freeReg ) {
		right.evalCode( freeReg );
		Code.instrn( opCode, 
			Code.tempReg( freeReg ), Code.tempReg( freeReg ) );
		}

	}
