package node.exprNode;

import code.*;
import node.*;

public class ExprListNode extends ListNode< ExprNode > {

	public ExprListNode() {
		super( ", " );
		}
	
	public ExprListNode( ExprNode node ) {
		this();
		addElement( node );
		}
		
	public void evalCode() {
		for ( int i = 0; i < size(); i++ ) {
			ExprNode expr = elementAt( i );
			expr.evalCode( 0 );
			Code.instrn( "mov", "$t0", Code.argReg( i ) );
			}
		}
	}
