package node.stmtNode;

import env.*;
import node.*;
import text.*;

import java.util.*;

public class StmtListNode extends ListNode< StmtNode > {

	public StmtListNode() {
		super( "%n" );
		}
	
	public StmtListNode( StmtNode node ) {
		this();
		addElement( node );
		}
		
	public void genDeclCode( Env env ) {
		for ( int i = 0; i < size(); i++ ) {
			StmtNode stmt = elementAt( i );
			stmt.genDeclCode( env );
			}
		}
		
	public void genCode() {
		for ( int i = 0; i < size(); i++ ) {
			StmtNode stmt = elementAt( i );
			stmt.genCode();
			}
		}
		
	}

